/*
 * Licensed Materials - Property of IBM
 * IBM Sterling Field Sales
 * (C) Copyright IBM Corp. 2009, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
Ext.namespace('sc.sfs.helper');

Ext.namespace('sc.sfs.App');

sc.sfs.App.Action = {};

sc.sfs.App.Context = "/" + sc.plat.info.Application.getApplicationContext();

sc.sfs.App.CreateAction = "create";

sc.sfs.App.ManageAction = "manage";

sc.sfs.App.DetailsAction = "view";

sc.sfs.App.StrutsFilter = ".do";

sc.sfs.App.GlobalStrutsNS = "/sfs";

sc.sfs.App.HomeEntity = "home";

sc.sfs.App.QuoteEntity = "quote";

sc.sfs.App.OpportunityEntity = "opportunity";

sc.sfs.App.QuoteStrutsNS = "/sfs/quotes";

sc.sfs.App.OpportunityStrutsNS = "/sfs/opportunity";

sc.sfs.App.CommonStrutsNS = "/sfs/common";

sc.sfs.App.ContainerAction = "container";

sc.sfs.App.RelatedTaskAction = "relatedtask";

sc.sfs.App.InputNS = {};

sc.sfs.App.InputNS.global = "inputdata";


sc.sfs.helper.AppHelper = {

	loadEntity : function(action, ns , param) {
		var url = this.getURLWithContainer(action, ns);
		url = this.appendVariableToByPassIECache(url);
		sc.plat.FormUtils.request({
		url : url,
		method : 'POST',
		params : param
		});

	},
	appendVariableToByPassIECache : function(url){
	    if(Ext.isIE){
	       return sc.plat.RequestUtils.bypassCacheUrl(url);
		}else{
		   return url;
		}
	},
	loadEntityWithOrgCode : function(action, ns , orgcode , param) {
		var url = this.getURLWithContainer(action, ns);
		param = this.addOrgCodeInURL(orgcode, param);
		sc.plat.FormUtils.request({
		url : url,
		method : 'POST',
		params : param
		});
	},
	getURLWithContainer : function(action, ns, param) {
		if(ns === sc.sfs.App.GlobalStrutsNS){
			ns = "";
		}else if(ns === sc.sfs.App.QuoteStrutsNS){
			ns = "/quotes";
		}else if(ns === sc.sfs.App.OpportunityStrutsNS){
			ns = "/opportunity";
		}
		//if(param){			
		//		this.createURLInput(param);
		//}
		return this.getContainerURL() +ns+"/"+action+sc.sfs.App.StrutsFilter;
	},
	getContainerURL : function() {
		return sc.sfs.App.Context + sc.sfs.App.GlobalStrutsNS + "/"
				+ sc.sfs.App.ContainerAction;
	},
	getRelatedTaskURL : function(){
		return sc.sfs.App.Context + sc.sfs.App.GlobalStrutsNS + "/" 
			+ sc.sfs.App.RelatedTaskAction + sc.sfs.App.StrutsFilter;
	},
	getAjaxURL : function(action, ns) {
		return sc.sfs.App.Context + ns + "/" + action + sc.sfs.App.StrutsFilter;
	},
	addParamInURL : function(url , param){
		param = sc.plat.RequestUtils.addAdditionalParams(param, "GET");
		if(typeof param == "object"){
        	param = Ext.urlEncode(param);
    	}
		if(param)
			url = url + (url.indexOf('?') != -1 ? '&' : '?') + param;
		return url;
	},
	addOrgCodeInURL : function(orgcode, param){
		var paramName = sc.sfs.core.context.AppContext.getOrgCodeParamName();
		param = sc.plat.RequestUtils.addParam(paramName,orgcode, param );
		return param;
	},
	addParamInHref : function(url){
		return sc.plat.RequestUtils.addAdditionalParamsInURL(url, "GET");
	},
	
	getURLForWindowHref : function(url){
		return sc.sfs.helper.AppHelper.addParamInHref("/"+sc.plat.info.Application.getApplicationContext() + url);
	},
	getAppContext : function(url){
		return sc.sfs.App.Context + url + (url.indexOf('?') != -1 ? '&' : '?') + 'scCSRFToken=' + sc.plat.info.Application.getCSRFToken();
	},
	getCompleteURL : function(url , param){
		url = location.protocol + "//" + location.host + sc.sfs.App.Context +  url ;
		
		if(param){
			param = sc.plat.RequestUtils.addAdditionalParams(param, "GET");
			if(typeof param == "object"){
	        	param = Ext.urlEncode(param);
	    	}
			if(param)
				url = url + (url.indexOf('?') != -1 ? '&' : '?') + param;			
		}else{
			url = url + (url.indexOf('?') != -1 ? '&' : '?') + 'scCSRFToken=' + sc.plat.info.Application.getCSRFToken();
		}
		return url;
	
	},
	getCompleteURLForPost : function(url) {
		url = location.protocol + "//" + location.host + sc.sfs.App.Context + url;

		return url;

	},
	getComleteURLWithCSRFToken : function(url, param){
		url = location.protocol + "//" + location.host + sc.sfs.App.Context + url;

		if (param) {
			param = sc.plat.RequestUtils.addAdditionalParams(param, "POST");
			if (typeof param == "object") {
				param = Ext.urlEncode(param);
			}
			if (param)
				url = url + (url.indexOf('?') != -1 ? '&' : '?') + param;
		} else {
			url = sc.plat.RequestUtils.addCSRFTokenInURL(url, "POST");;
		}
		return url;
	},

	appendCSRFToken : function(url){
		return sc.plat.RequestUtils.addCSRFTokenInURL(url, "GET");
	},
	openWindowAsPost : function(url, cnfg, targetName){
		var form = document.createElement("form");
		form.setAttribute("method", "post");
		form.setAttribute("action", url);		
		form.setAttribute("target", targetName);
		
		for(var key in cnfg){
            var attrName = key;
            var attrValue = cnfg[key];
            
			var hiddenField = document.createElement("input");
			hiddenField.setAttribute("name", attrName);
			hiddenField.setAttribute("value", attrValue);
			hiddenField.setAttribute("type", "hidden");
			form.appendChild(hiddenField);
        }
		var hiddenField = document.createElement("input");
		hiddenField.setAttribute("name", sc.plat.RequestUtils.csrfTokenParamName);
		hiddenField.setAttribute("value", sc.plat.info.Application.getCSRFToken());
		hiddenField.setAttribute("type", "hidden");
		form.appendChild(hiddenField);
        
		document.body.appendChild(form);
		
		var win = window.open('', targetName, 'scrollbars=no,menubar=no,height=600,width=800,resizable=yes,toolbar=no,status=no');	
		form.submit();
		return win ;
	},
	loadContainerURL : function(url) {
		sc.plat.FormUtils.request({
			url : url,
			method : 'POST'
		});
	}
}